unit CwTickerU;

// This source code was written by David Fentem, KW4M, and is hereby released into the public domain.

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DxSoftEx;

type
  TForm1 = class(TForm)
    ClearBtn  : TButton;
    ExitBtn   : TButton;
    TickerLbl : TLabel;
    procedure ClearBtnClick (Sender: TObject);
    procedure ExitBtnClick  (Sender: TObject);
    procedure FormActivate  (Sender: TObject);
    procedure FormCreate    (Sender: TObject);
    procedure FormResize    (Sender: TObject);
  private
    CwString      : string;
    MaxLabelWidth : integer;
    procedure MyIdleHandler (Sender: TObject; var Done: Boolean);
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
   ClearCwRxBuffer;
   CwString          := '';
   TickerLbl.Caption := CwString;
end;

procedure TForm1.ExitBtnClick(Sender: TObject);
begin
   Close;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   if not LoadDxSoftExDll then
      begin
         ShowMessage ('Could not initialize DXSOFTEX.DLL.');
         Close;
      end;

   CwString := '';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Application.OnIdle:= MyIdleHandler;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   MaxLabelWidth := ClientWidth - 30;
end;

procedure TForm1.MyIdleHandler(Sender: TObject; var Done: Boolean);
var
   LabelWidth : integer;
   Len        : integer;
   Ch         : char;
begin
   sleep (50);
   Done := false;

   if GetCwRxChar (Ch) then
      begin
         CwString          := CwString + Ch;
         TickerLbl.Caption := CwString;

         LabelWidth := TickerLbl.Width;
         while (LabelWidth > MaxLabelWidth) do
            begin
               Len               := length(CwString) - 1;
               CwString          := copy (CwString, 2, Len);
               TickerLbl.Caption := CwString;
               LabelWidth        := TickerLbl.Width;
            end;
      end;
end;

end.
